<template lang="pug">
    v-container(fluid)
        v-row(v-if='albums.length' dense)
            v-col(v-for='album in albums' :key='album.id' cols='4')
                PreviewAlbum(:album='album' @favorite='favorite' @remove='remove')
        template(v-else)
            h3.text-center Vous n'avez pas encore d'albums dans votre biblitohèque, vous pouvez en ajouter 
                a(@click="$router.push('/search')") ici

        v-dialog(v-model='dialog' max-width='500px' @click:outside='cleanForm')
            v-card
                v-card-text
                    v-text-field(v-model='newTag' label='Tag')
                    v-autocomplete(v-model='selectedAlbums' :items='albums' item-text='name' item-value='id' return-object multiple clearable)
                v-card-actions
                    v-spacer
                    v-btn(text color='primary' @click='addTag') Valider

        v-speed-dial(v-model='fab' bottom right fixed direction='top' :open-on-hover='true')
            template(v-slot:activator='')
                v-btn(v-model='fab' color='primary' dark fab)
                    v-icon(v-if='fab') close
                    v-icon(v-else) menu


            v-tooltip(left)
                template(v-slot:activator='{ on, attrs }')
                    v-btn(fab dark small color='green' v-on='on' v-bind='attrs' @click="$router.push('/search')")
                        v-icon add
                | Ajouter des albums
            v-tooltip(left)
                template(v-slot:activator='{ on, attrs }')
                    v-btn(fab dark small color='indigo' v-on='on' v-bind='attrs' @click="dialog = true")
                        v-icon label
                | Ajouter des tags
</template>

<script>
import requests from "@/services/requests.js";
import PreviewAlbum from "@/components/PreviewAlbum";
export default {
	name: "Library",
	components: {
		PreviewAlbum,
	},
	data() {
		return {
			dialog: false,
			fab: false,
			newTag: "",
			albums: [],
			selectedAlbums: [],
		};
	},
	mounted() {
		this.getAlbums();
	},
	methods: {
		getAlbums() {
			// call request to get saved albums of current user
			requests.getAlbums(this.$store.state.user)
				.then((r) => {
					this.albums = r;
				});
		},
		remove(album) {
			// Remove an album from the library
			requests
				.removeAlbum(this.$store.state.user, album)
				.then(this.getAlbums);
		},
		favorite(album) {
			// Change the favorite attribute of the album. A sort could be implemented to display favorite albums at the beginning
			requests
				.favoriteAlbum(this.$store.state.user, album)
				.then(this.getAlbums);
		},
		addTag() {
			// Add tag to selected albums
			if (this.newTag && this.selectedAlbums.length) {
				requests
					.addTag(this.$store.state.user, this.newTag, this.selectedAlbums)
					.then(this.getAlbums);
			}
			// Close form and clean variables
			this.dialog = false;
			this.cleanForm();
		},
		cleanForm() {
			this.newTag = "";
			this.selectedAlbums = [];
		},
	},
};
</script>
